unit headersfrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, mbox;

type
  TfrmHeaders = class(TForm)
    sgHeaders: TStringGrid;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    FMailItem : TMailMessage;
    procedure SetMailItem( Item : TMailMessage );
  public
    { Public declarations }
    property MailItem : TMailMessage write SetMailItem;
  end;

var
  frmHeaders: TfrmHeaders;

implementation

(*

  Esto muestra cmo podemos utilizar tecnologa de objetos incluso
  cuando no estamos escribiendo componentes. Si usted se fija en nuestra
  seccin public, hemos hecho una propiedad con get y set para el mensaje.
  La propiedad Set actualiza la interfaz del usuario para esta forma, mostrando
  las propiedades del mensaje. Esto le permite a cualquier programa actualizar
  toda la forma simplemente haciendo algo como
  frmHeaders.MailItem := MensajeActual. Delphi es una MARAVILLA!

*)

procedure TfrmHeaders.setMailItem( Item : TMailMessage );
var
  i : Integer;
begin

  for i := 0 to sgHeaders.ColCount - 1 do sgHeaders.Cols[i].Clear;
  sgHeaders.RowCount := item.Attributes.Count +1;
  sgHeaders.Cells[0,0] := 'Atributo';
  sgHeaders.Cells[1,0] := 'Valor';
  for i := 0 to item.Attributes.Count - 1 do begin
    sgHeaders.Cols[0].Add(Item.Attributes.Names[i]);
    sgHeaders.Cols[1].Add(Item.Attributes.Values[Item.Attributes.Names[i]]);
  end;
  FMailItem := Item;

end;

{$R *.DFM}

procedure TfrmHeaders.FormClose(Sender: TObject; var Action: TCloseAction);
begin

  Action := caHide;

end;

procedure TfrmHeaders.FormResize(Sender: TObject);
begin

  // Al cambiar de tamao, tambin cambia de ancho las columnas del Grid.
  if Width > 340 then begin
    sgHeaders.ColWidths[0] := Width div 4;
    sgHeaders.ColWidths[1] := Width - sgHeaders.ColWidths[0];
    if Width > 300 then sgHeaders.ColWidths[0] := Width div 4;
  end else begin
    sgHeaders.ColWidths[0] := Width div 2;
    sgHeaders.ColWidths[1] := Width div 2;
  end;


end;

end.
